<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::avs::attachment::Attachment Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html">avs</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment.html">attachment</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html">Attachment</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::avs::attachment::Attachment Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_attachment_8h_source.html">Attachment.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::avs::attachment::Attachment:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment.html" title="alexaClientSDK::avsCommon\l::avs::attachment::InProcessAttachment" alt="" coords="5,92,262,131"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a615eadb8b67ff9c65479804411dcb071"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a615eadb8b67ff9c65479804411dcb071">Attachment</a> (const std::string &amp;attachmentId)</td></tr>
<tr class="separator:a615eadb8b67ff9c65479804411dcb071"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d758b6740e6c0ca58477593e90721ec"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a7d758b6740e6c0ca58477593e90721ec">~Attachment</a> ()=default</td></tr>
<tr class="separator:a7d758b6740e6c0ca58477593e90721ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2c10d170f8cf7ac006d60453a63a436"><td class="memItemLeft" align="right" valign="top">virtual std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">AttachmentWriter</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#ae2c10d170f8cf7ac006d60453a63a436">createWriter</a> (<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">utils::sds::WriterPolicy</a> policy=<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1">utils::sds::WriterPolicy::ALL_OR_NOTHING</a>)=0</td></tr>
<tr class="separator:ae2c10d170f8cf7ac006d60453a63a436"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cfb73571b5b7fc43c663b31c1fe055a"><td class="memItemLeft" align="right" valign="top">virtual std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">AttachmentReader</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a1cfb73571b5b7fc43c663b31c1fe055a">createReader</a> (<a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">utils::sds::ReaderPolicy</a> policy)=0</td></tr>
<tr class="separator:a1cfb73571b5b7fc43c663b31c1fe055a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a026e8930e2279029f7961c8aef3a6969"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a026e8930e2279029f7961c8aef3a6969">getId</a> () const</td></tr>
<tr class="separator:a026e8930e2279029f7961c8aef3a6969"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cdc5bcb626d5ba0acf1991daae5eb54"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a7cdc5bcb626d5ba0acf1991daae5eb54">hasCreatedReader</a> ()</td></tr>
<tr class="separator:a7cdc5bcb626d5ba0acf1991daae5eb54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb3941a2eeb0deb2b4f2546fb7e8f243"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#acb3941a2eeb0deb2b4f2546fb7e8f243">hasCreatedWriter</a> ()</td></tr>
<tr class="separator:acb3941a2eeb0deb2b4f2546fb7e8f243"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:ad3d8c95c98c75b7505ddad4fd6529a82"><td class="memItemLeft" align="right" valign="top">const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#ad3d8c95c98c75b7505ddad4fd6529a82">m_id</a></td></tr>
<tr class="memdesc:ad3d8c95c98c75b7505ddad4fd6529a82"><td class="mdescLeft">&#160;</td><td class="mdescRight">The id for this attachment object.  <a href="#ad3d8c95c98c75b7505ddad4fd6529a82">More...</a><br /></td></tr>
<tr class="separator:ad3d8c95c98c75b7505ddad4fd6529a82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b86815f3305c8b7e3bdcd444a5cc263"><td class="memItemLeft" align="right" valign="top">std::mutex&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a7b86815f3305c8b7e3bdcd444a5cc263">m_mutex</a></td></tr>
<tr class="memdesc:a7b86815f3305c8b7e3bdcd444a5cc263"><td class="mdescLeft">&#160;</td><td class="mdescRight">mutex to protext access to the createReader and createWriter API.  <a href="#a7b86815f3305c8b7e3bdcd444a5cc263">More...</a><br /></td></tr>
<tr class="separator:a7b86815f3305c8b7e3bdcd444a5cc263"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af15da74867a114bd7ea916de03be3245"><td class="memItemLeft" align="right" valign="top">std::atomic&lt; bool &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#af15da74867a114bd7ea916de03be3245">m_hasCreatedWriter</a></td></tr>
<tr class="memdesc:af15da74867a114bd7ea916de03be3245"><td class="mdescLeft">&#160;</td><td class="mdescRight">An atomic tracking variable to tell whether this object has created a writer.  <a href="#af15da74867a114bd7ea916de03be3245">More...</a><br /></td></tr>
<tr class="separator:af15da74867a114bd7ea916de03be3245"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bb75e8d2aac17a2d95950ff697aace6"><td class="memItemLeft" align="right" valign="top">std::atomic&lt; bool &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html#a0bb75e8d2aac17a2d95950ff697aace6">m_hasCreatedReader</a></td></tr>
<tr class="memdesc:a0bb75e8d2aac17a2d95950ff697aace6"><td class="mdescLeft">&#160;</td><td class="mdescRight">An atomic tracking variable to tell whether this object has created a reader.  <a href="#a0bb75e8d2aac17a2d95950ff697aace6">More...</a><br /></td></tr>
<tr class="separator:a0bb75e8d2aac17a2d95950ff697aace6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">A class that represents an AVS attachment. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a615eadb8b67ff9c65479804411dcb071"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a615eadb8b67ff9c65479804411dcb071">&#9670;&nbsp;</a></span>Attachment()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::avs::attachment::Attachment::Attachment </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>attachmentId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">attachmentId</td><td>The id for this attachment. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7d758b6740e6c0ca58477593e90721ec"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7d758b6740e6c0ca58477593e90721ec">&#9670;&nbsp;</a></span>~Attachment()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::avs::attachment::Attachment::~Attachment </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a1cfb73571b5b7fc43c663b31c1fe055a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cfb73571b5b7fc43c663b31c1fe055a">&#9670;&nbsp;</a></span>createReader()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::unique_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">AttachmentReader</a>&gt; alexaClientSDK::avsCommon::avs::attachment::Attachment::createReader </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">utils::sds::ReaderPolicy</a>&#160;</td>
          <td class="paramname"><em>policy</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a reader object, with which the <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html">Attachment</a> may be read from.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>policy used to configure the reader. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>a  to an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">AttachmentReader</a>. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment.html#a9d2b85c167f2832e497dd5e3b46f0814">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachment</a>.</p>

</div>
</div>
<a id="ae2c10d170f8cf7ac006d60453a63a436"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2c10d170f8cf7ac006d60453a63a436">&#9670;&nbsp;</a></span>createWriter()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual std::unique_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">AttachmentWriter</a>&gt; alexaClientSDK::avsCommon::avs::attachment::Attachment::createWriter </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">utils::sds::WriterPolicy</a>&#160;</td>
          <td class="paramname"><em>policy</em> = <code><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5a5d027622828a53a8fc66dd131952c8a1">utils::sds::WriterPolicy::ALL_OR_NOTHING</a></code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a writer object, with which the <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment.html">Attachment</a> may be written to.</p>
<dl class="section return"><dt>Returns</dt><dd>a  to an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">AttachmentWriter</a>. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment.html#a364cac617a687fc4e8a01946c2b2955e">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachment</a>.</p>

</div>
</div>
<a id="a026e8930e2279029f7961c8aef3a6969"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a026e8930e2279029f7961c8aef3a6969">&#9670;&nbsp;</a></span>getId()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::avs::attachment::Attachment::getId </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">An accessor to get the attachmentId.</p>
<dl class="section return"><dt>Returns</dt><dd>The attachment Id. </dd></dl>

</div>
</div>
<a id="a7cdc5bcb626d5ba0acf1991daae5eb54"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7cdc5bcb626d5ba0acf1991daae5eb54">&#9670;&nbsp;</a></span>hasCreatedReader()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::avs::attachment::Attachment::hasCreatedReader </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Utility function to tell if a reader has been created for this object.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether a reader has been created for this object. </dd></dl>

</div>
</div>
<a id="acb3941a2eeb0deb2b4f2546fb7e8f243"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acb3941a2eeb0deb2b4f2546fb7e8f243">&#9670;&nbsp;</a></span>hasCreatedWriter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::avs::attachment::Attachment::hasCreatedWriter </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Utility function to tell if a writer has been created for this object.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether a writer has been created for this object. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a0bb75e8d2aac17a2d95950ff697aace6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0bb75e8d2aac17a2d95950ff697aace6">&#9670;&nbsp;</a></span>m_hasCreatedReader</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::atomic&lt;bool&gt; alexaClientSDK::avsCommon::avs::attachment::Attachment::m_hasCreatedReader</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>An atomic tracking variable to tell whether this object has created a reader. </p>

</div>
</div>
<a id="af15da74867a114bd7ea916de03be3245"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af15da74867a114bd7ea916de03be3245">&#9670;&nbsp;</a></span>m_hasCreatedWriter</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::atomic&lt;bool&gt; alexaClientSDK::avsCommon::avs::attachment::Attachment::m_hasCreatedWriter</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>An atomic tracking variable to tell whether this object has created a writer. </p>

</div>
</div>
<a id="ad3d8c95c98c75b7505ddad4fd6529a82"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3d8c95c98c75b7505ddad4fd6529a82">&#9670;&nbsp;</a></span>m_id</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string alexaClientSDK::avsCommon::avs::attachment::Attachment::m_id</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The id for this attachment object. </p>

</div>
</div>
<a id="a7b86815f3305c8b7e3bdcd444a5cc263"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b86815f3305c8b7e3bdcd444a5cc263">&#9670;&nbsp;</a></span>m_mutex</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::mutex alexaClientSDK::avsCommon::avs::attachment::Attachment::m_mutex</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>mutex to protext access to the createReader and createWriter API. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/AVS/include/AVSCommon/AVS/Attachment/<a class="el" href="_attachment_8h_source.html">Attachment.h</a></li>
<li>/workplace/avs-device-sdk/AVSCommon/AVS/src/Attachment/<a class="el" href="_attachment_8cpp.html">Attachment.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
